//******************************************************************************
//! @file $Id: lin_drv.h 581 2008-02-25 10:22:47Z jtellier $
//!
//! 쌠 (c) 2008 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɊւĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͈ȉ̒ʊ֐̧ق͈ȉ̒ʊ֐(ײ)̌^ϸ
//!		   ܂݂܂B
//!			- LIN/UARTLIN
//!			- ATmega32/64/M1/C1p
//!			- ATtiny167p
//!
//! ̧قAVRStudio-413571/WinAVR-20071221ŊmF܂B
//!
//******************************************************************************

#ifndef _LIN_DRV_H_
#define _LIN_DRV_H_

//_____ ݸٰ ________________________________________________________________
#include "config.h"

//_____ ` ___________________________________________________________________

// ---- ޯĎ

#ifndef FOSC
  #error You must define FOSC
#elif FOSC == 16000							// ޲g=16MHz̏ꍇ
  #ifndef LIN_BAUDRATE
	#error You must define LIN_BAUDRATE
  #elif LIN_BAUDRATE == 19200
	#define CONF_LINBRR			25			// (0x19) 19.2kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 9600
	#define CONF_LINBRR			51			// (0x33) 9.6kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 4800
	#define CONF_LINBRR			103			// (0x67) 4.8kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 2400
	#define CONF_LINBRR			207			// (0xCF) 2.4kbpsA덷=-0.2%
  #else
	#error Not available LIN_BAUDRATE value
  #endif

#elif FOSC == 8000							// ޲g=8MHz̏ꍇ
  #ifndef LIN_BAUDRATE
	#error You must define LIN_BAUDRATE
  #elif LIN_BAUDRATE == 19200
	#define CONF_LINBRR			12			// (0x0C) 19.2kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 9600
	#define CONF_LINBRR			25			// (0x19) 9.6kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 4800
	#define CONF_LINBRR			51			// (0x33) 4.8kbpsA덷=0.2%
  #elif LIN_BAUDRATE == 2400
	#define CONF_LINBRR			103			// (0x67) 2.4kbpsA덷=-0.2%
  #else
	#error Not available LIN_BAUDRATE value
  #endif
#else
	#error Not available FOSC value
#endif

// ---- `Ԑݒ

	// LINK
#define LIN_1X			(1<<LIN13)
#define LIN_2X			(0<<LIN13)

	// LIN
#define LIN_CMD_MASK	((1<<LCMD1)|(1<<LCMD0))
#define LIN_RX_HEADER	((0<<LCMD1)|(0<<LCMD0))
#define LIN_ABORT		((0<<LCMD1)|(0<<LCMD0))
#define LIN_TX_HEADER	((0<<LCMD1)|(1<<LCMD0))
#define LIN_RX_RESPONSE	((1<<LCMD1)|(0<<LCMD0))
#define LIN_TX_RESPONSE	((1<<LCMD1)|(1<<LCMD0))

	// LIN荞׸
#define LIN_ERROR		(1<<LERR )
#define LIN_IDOK		(1<<LIDOK)
#define LIN_RXOK		(1<<LRXOK)
#define LIN_TXOK		(1<<LTXOK)

	// LIN IDՕ
#define LIN_1X_ID_MASK	((1<<LID3)|(1<<LID2)|(1<<LID1)|(1<<LID0))
#define LIN_1X_LEN_MASK	((1<<LID5)|(1<<LID4))
#define LIN_2X_ID_MASK	((1<<LID5)|(1<<LID4)| LIN_1X_ID_MASK )

	// ATmega64/32/M1/C1L
#define LIN_PORT_IN		PIND
#define LIN_PORT_DIR	DDRD
#define LIN_PORT_OUT	PORTD
#define LIN_INPUT_PIN	4
#define LIN_OUTPUT_PIN	3

//_____ ϸ ____________________________________________________________________

// ---- LIN 1.xKgp

#define Lin_1x_set_type()		( LINCR|= LIN_1X )
#define Lin_1x_enable()			( LINCR = LIN_1X|(1<<LENA)|(0<<LCMD2) )
#define Lin_1x_set_id(id)		{ LINIDR &= ~LIN_1X_ID_MASK; LINIDR |= id & LIN_1X_ID_MASK; }
#define Lin_1x_set_len(len)		{ LINIDR &= ~LIN_1X_LEN_MASK; LINIDR |= (((len+4)<<2) & LIN_1X_LEN_MASK); }
#define Lin_get_len()			( LINDLR & (0x0F << LRXDL0) )
// Lin_set_rx_len(len) ........ LIN 1.xŉɑ΂Ďݒ
// Lin_set_tx_len(len) ........ LIN 1.xŉɑ΂Ďݒ

// ---- LIN 2.xKgp

#define Lin_2x_set_type()		( LINCR|= LIN_2X )
#define Lin_2x_enable()			( LINCR = LIN_2X|(1<<LENA)|(0<<LCMD2) )
#define Lin_2x_set_id(id)		{ LINIDR &= ~LIN_2X_ID_MASK; LINIDR |= id & LIN_2X_ID_MASK; }
// Lin_2x_set_len(len) ........ LIN 2.1ŗps
// Lin_get_len() .............. LIN 2.1ŗps
#define Lin_set_rx_len(len)		( LINDLR = len & (0x0F << LRXDL0) )
#define Lin_set_tx_len(len)		( LINDLR = len << LTXDL0 )

// ---- pC-ϸ

	// ǂ̋Kłgp
#define Lin_set_type(ltype)		(( ltype == LIN_2X ) ? Lin_2x_set_type(): Lin_1x_set_type() )
#define Lin_get_type()			( LINCR & (1<<LIN1X) )
#define Lin_set_len(len)		( LINDLR = (len<<LTXDL0)|(len &(0x0F<<LRXDL0) )

	// ̑C-ϸ
#define Lin_get_error_status()	( LINERR )
#define Lin_set_baudrate(br)	{ LINBRRH = (unsigned char)(((unsigned short)br)>>8); \
								  LINBRRL = (unsigned char) ((unsigned short)br);	  }
#define Lin_sw_reset()			( LINCR = 1<<LSWRES )
#define Lin_full_reset()		{ Lin_sw_reset(); Lin_clear_enable_it(); LINBRRL = 0x00; LINBRRH = 0x00; }

// 荞ݏ
#define Lin_get_it()			( LINSIR & ((1<<LERR)|(1<<LIDOK)|(1<<LTXOK)|(1<<LRXOK)) )
#define Lin_set_enable_it()		( LINENIR = (1<<LENERR)|(1<<LENIDOK)|(1<<LENTXOK)|(1<<LENRXOK) )
#define Lin_clear_enable_it()	( LINENIR = (0<<LENERR)|(0<<LENIDOK)|(0<<LENTXOK)|(0<<LENRXOK) )
#define Lin_clear_err_it()		( LINSIR = 1<<LERR  )
#define Lin_clear_idok_it()		( LINSIR = 1<<LIDOK )
#define Lin_clear_txok_it()		( LINSIR = 1<<LTXOK )
#define Lin_clear_rxok_it()		( LINSIR = 1<<LRXOK )

// LIN
#define Lin_abort()				( LINCR &= ~LIN_CMD_MASK )
#define Lin_rx_header()			( LINCR &= ~LIN_CMD_MASK )
#define Lin_tx_header()			{ LINCR &= ~LIN_CMD_MASK; LINCR|= LIN_TX_HEADER ;  }
#define Lin_rx_response()		{ LINCR &= ~LIN_CMD_MASK; LINCR|= LIN_RX_RESPONSE; }
#define Lin_tx_response()		{ LINCR &= ~LIN_CMD_MASK; LINCR|= LIN_TX_RESPONSE; }

// LIN
#define Is_lin_header_ready()		( (LINSIR & (1<<LIDOK)) ? 1 : 0 )
#define Is_lin_rx_response_ready()	( (LINSIR & (1<<LRXOK)) ? 1 : 0 )
#define Is_lin_tx_response_ready()	( (LINSIR & (1<<LTXOK)) ? 1 : 0 )

// IDް̏
#define Lin_get_id()			( LINIDR & LIN_2X_ID_MASK)
#define Lin_clear_index()		( LINSEL = (0<<LAINC)|(0x00<<LINDX0) )
#define Lin_get_data()			( LINDAT )
#define Lin_set_data(data)		( LINDAT = data )

//_____ ^ ___________________________________________________________________

extern unsigned char lin_init (unsigned char l_type, unsigned long b_rate);
extern unsigned char lin_tx_header (unsigned char l_type, unsigned char l_id, unsigned char l_len);
extern unsigned char lin_rx_response (unsigned char l_type, unsigned char l_len);
extern unsigned char lin_tx_response (unsigned char l_type, unsigned char *l_data, unsigned char l_len);
extern void lin_get_response (unsigned char *l_data);

//______________________________________________________________________________

#endif // _LIN_DRV_H_
