//-----------------------------------------------------------------------
// \ : lin_master_example.c
//-----------------------------------------------------------------------

//----- ݸٰ
#include "config.h"
#include "lin_drv.h"
#include <avr/interrupt.h>					// AVR-GCCײ؎gp

//----- 錾
#define LIN_ID_0		0x12
#define LIN_ID_1		0x13

#define LEN_0			1
#define LEN_1			2

#define MAGIC_NUMBER	77

unsigned char lin_motor_command[LEN_0];
unsigned char lin_slave_node_status[LEN_1];

volatile unsigned char lin_master_err_nb = 0;

volatile unsigned char rtc_tics = 0;

//----- ֐ ------------------------------------------------------------

//.......................................................................
// "lin_master_example.c"lin_id_task֐
//
//	MLIN ID͌Aߓ_(ɰ)ǗȂ΂ȂȂ̂Ɣr
//	Ȃ΂Ȃ܂B
//.......................................................................
void lin_id_task (void)
{
	switch (Lin_get_id()) {
		case LIN_ID_0:
			lin_tx_response(LIN_2X, lin_motor_command, LEN_0);
			break;
		case LIN_ID_1:
			lin_rx_response(LIN_2X, LEN_1);
			break;
		default:
			// ID:s/
			break;
	}
}

//.......................................................................
// "lin_master_example.c"lin_rx_task֐
//
//	- ްۑ
//	- pMXV
//.......................................................................
void lin_rx_task (void)
{
	lin_get_response (lin_slave_node_status);

	// ]ߓ_(ɰ)ɉĖOKňُȂȂA
	//	- PORTB[6]=0
	//	- Ȃ΁APORTB[6]=1
	if (lin_slave_node_status[0] != lin_motor_command[0])
	{
		PORTB |= 1<<PORT6;
	}
	else if (lin_slave_node_status[1] != 0)
	{
		PORTB |= 1<<PORT6;
	}
	else
	{
		PORTB &= ~(1<<PORT6);
	}
}

//.......................................................................
// "lin_master_example.c"lin_tx_task֐
//
//	- ̑M𐮂邽߂ɉpMŊɏՕzXV
//.......................................................................
void lin_tx_task (void)
{
	// pM(Low)̍XV
	lin_motor_command[0] = (~PINB) & 0x03;
}

//.......................................................................
// "lin_master_example.c"lin_err_task֐
//
//	- LINُȂAߓ_(ɰ)ُԍ𑝉
//.......................................................................
void lin_err_task (void)
{
	// SϐXV
	lin_master_err_nb++;
}

//.......................................................................
//
// "lin_master_example.c"OCR0A荞ݏٰ
//
//	AVR-GCC錾():
//		ISR(TIMER0_COMPA_vect)
//	IAR錾:
//		#pragma vector TIMER0_COMPA_vect
//		__interrupt void timer0_compa_vect(void)
//
//	rtc_ticlɏ]ēK؂LIN擪܂B
////.......................................................................
ISR(TIMER0_COMPA_vect)
{
	rtc_tics++;

	if((rtc_tics & 0x01) == 0x01)
	{
		lin_tx_header((unsigned char)LIN_2X, (unsigned char)LIN_ID_0, 0);
	}
	else
	{
		lin_tx_header((unsigned char)LIN_2X, (unsigned char)LIN_ID_1, 0);
	}
}

//.......................................................................
//. . . m a i n ( )
//
// "lin_master_example.c"mian֐
//
//	'I薳'ňȉsAJԂ܂B
//		- LIN_ID_0(M1޲)ȂA
//			EPORT-B.0 = DCd@߁ˎv
//			EPORT-B.1 = DCd@߁˔v
// 		- LIN_ID_1(M2޲)ȂA
//			EByte[0] = d@
//			EByte[1] = ]ߓ_(ɰ)ُԍ
//	v0͊e擪20msԊuő邱Ƃۏ؂܂B
//.......................................................................
int main (void)
{
	// d@p߰Bݒ
	// PORTB0PORTB1͓ٱ߂ƂLow؂芷܂B
	DDRB &= ~(1<<PORTB0); DDRB &= ~(1<<PORTB1);
	PORTB |= 1<<PORTB0; PORTB |= 1<<PORTB1;

	// d@׸ޗp߰Bݒ
	DDRB |= 1<<PORTB6;
	PORTB &= ~(1<<PORTB6);

	// LIN
	lin_init((unsigned char)LIN_2X, ((unsigned short)CONF_LINBRR));

	// v0Ɗ荞݂̏(o͂Ȃ)
		// v0ؾ
	TIMSK0 = 0; TCCR0B = 0; TCCR0A = 0; TCNT0 = 0; OCR0A = 0;
	TIFR0 = ((1<<OCF0A) | (1<<TOV0));
		// o͂ȂA2A10ms荞
	TCCR0A = 0x02; OCR0A = MAGIC_NUMBER; TCCR0B = 0x05;
		// v0rA荞݋
	TIMSK0 |= 1<<OCIE0A;
	asm ("sei");

	// I薳JԂ
	while (1)
	{
		switch (Lin_get_it())
		{
			case LIN_IDOK:
				lin_id_task();
				Lin_clear_idok_it();
				break;
			case LIN_RXOK:
				lin_rx_task();
				Lin_clear_rxok_it();
				break;
			case LIN_TXOK:
				lin_tx_task();
				Lin_clear_txok_it();
				break;
			case LIN_ERROR:
				lin_err_task();
				Lin_clear_err_it();
				break;
			default:
				break;
		}
	}
	return 0;
}
